import java.io.ByteArrayOutputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.io.IOException;
import java.net.Socket;
import java.net.InetAddress;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Button;

/**
 * ObjectApplet.java
 *
 *
 * Created: Wed Jan 03 13:53:23 2001
 *
 * @author Antonio Cisternino
 * @version 1.0
 */
public class ObjectApplet extends java.applet.Applet implements ActionListener {
  public void send(InetAddress addr, int p, 
                   String path, Serializable obj) throws IOException {
    // Save the object's instance
    ByteArrayOutputStream buffer = new ByteArrayOutputStream();
    ObjectOutputStream out = new ObjectOutputStream(buffer);
    out.writeObject(obj);

    // Prepare the header
    byte[] serobj = buffer.toByteArray();

    StringBuffer outb = new StringBuffer();
    outb.append("POST ");
    outb.append(path);
    outb.append(" HTTP/1.0\r\nUser-Agent: JavaObjectTunnel\r\n");
    outb.append("Content-Type: application/java-object\r\n");
    outb.append("Content-Length: ");
    outb.append(serobj.length);
    outb.append("\r\n\r\n");

    // Open the connection and send the data
    Socket s = new Socket(addr, p);
    OutputStream sout = s.getOutputStream();
    sout.write(outb.toString().getBytes());
    sout.write(serobj);
    sout.write("\r\n".getBytes());

    s.close();
  }

  public void init() {
    Button b = new Button("Invia");
    b.addActionListener(this);
    add(b);
  }

  public void actionPerformed(ActionEvent evt) {
    try {
      String s = "Hello Server";
      send(InetAddress.getByName(getCodeBase().getHost()), 8080, "/objser/servlet/ObjectServlet", s);
    } catch(IOException e) {
    }
  }
} // ObjectApplet
